;    PATTERN.COM   PATTERN GENERATOR   (Processor Technology)   
       ORG 00100H   
       LXI SP,0CBFFH    ; Set up stack for Processor Tech. programs
       LXI  H,0C004H    ; Needed if ORG is other then address 0000H
       PUSH H  
       LXI  H,0C000H    ; Residue address needed if non-Processor Tech.
                        ; system (CP/M) is used to LOAD the PROGRAM.   
START: JMP  H0027   
H0003: CALL H000A   
       JZ   H0003   
       RET  
;   
H000A: CALL H001C   
       RZ   
       CPI  ESC 
       JZ   H0019   
       CPI  DEL 
       JZ   H0051   
       RET  
;   
; H0019: JMP  ALS8  
H0019: JMP  CPM 
H001C: IN   000H
       NOP  
       ANI  040H
       RZ   
       IN   001H
       ANI  07FH
       RET  
;   
H0027: INX  H   
       MOV  A,M 
       CPI  0C3H
       JNZ  H004A   
       DCX  H   
       MOV  A,M 
       CPI  0   
       JZ   H003A   
       CPI  DEL 
       JNZ  H004A   
H003A: MVI  L,01FH  
       MOV  A,M 
       CPI  ':' 
       JNZ  H004A   
       SHLD H000A+1 
       MVI  L,4 
       SHLD H0019+1 
H004A: LXI  H,H0051 
       SHLD START+1 
       PCHL 
H0051: LXI  SP,H05A0
       XRA  A   
       STA  H020B   
       CALL H0229   
H005B: LXI  H,H023E 
       CALL H0468   
       LXI  H,H02C1 
       CALL H0215   
       CPI  'X' 
       JZ   H0100   
       CALL H00A9   
H006F: LXI  H,H039B 
       CALL H0215   
       CPI  'X' 
       JZ   H0100   
       CALL H00D7   
       CALL H00F4   
       CALL H0229   
       CALL H009A   
H0086: LXI  SP,H05A0
       CALL H0165   
       CALL H000A   
       JZ   H0086   
       ANI  00FH
       STA  H020C   
       JMP  H0086   
H009A: CALL H0229   
H009D: LXI  H,SCREEN
       XRA  A   
       OUT  0FEH
       OUT  0C8H
       MVI  B,0A0H  
       MOV  D,A 
       RET  
;   
H00A9: STA  HCE98   
       STA  HCE6A   
H00AF: CALL H021B   
       JNC  H00EC   
       LXI  H,HCE58 
       MOV  D,A 
       RAL  
       RAL  
       RAL  
       RAL  
       ANI  0F0H
H00BF: MOV  E,A 
       LDA  H020B   
       ORA  E   
       STA  H020B   
       MOV  A,D 
       MVI  D,5 
H00CA: DCR  D   
       RZ   
       RAR  
       JNC  H00D2   
       MVI  M,0A0H  
H00D2: DCX  H   
       DCX  H   
       JMP  H00CA   
H00D7: STA  HCEA7   
       STA  HCE6B   
       CALL H021B   
       JNC  H00F0   
       LXI  H,HCE61 
       ANI  00FH
       MOV  D,A 
       JMP  H00BF   
H00EC: POP  H   
       JMP  H005B   
H00F0: POP  H   
       JMP  H006F   
H00F4: LXI  H,H03C8 
       CALL H0215   
       ANI  00FH
       STA  H020C   
       RET  
;   
H0100: CALL H0229   
       LXI  H,H023E 
       CALL H0468   
       LXI  H,H03A9 
       CALL H0468   
       CALL H00F4   
       CALL H0229   
H0115: LXI  H,H01CD 
       SHLD H0211   
       MVI  A,'>'   
       STA  H0213   
H0120: LHLD H0211   
       LDA  H0213   
       MOV  C,A 
       MOV  A,M 
       STA  H020B   
       INX  H   
       DCR  C   
       JM   H0115   
       SHLD H0211   
       MOV  A,C 
       STA  H0213   
       LXI  H,H0700 
       SHLD H020D   
       LXI  SP,H05A0
       CALL H009D   
       LXI  H,HD000 
H0146: PUSH H   
       CALL H000A   
       JZ   H0152   
       ANI  00FH
       STA  H020C   
H0152: LHLD H020D   
       DCX  H   
       MOV  A,H 
       ORA  L   
       JZ   H0120   
       SHLD H020D   
       POP  H   
       CALL H0165   
       JMP  H0146   
H0165: LDA  H020B   
       MOV  E,A 
       DAD  D   
       MVI  A,0CFH  
       CMP  H   
       JNC  H0176   
       MVI  H,0CCH  
       MOV  A,B 
       XRI  080H
       MOV  B,A 
H0176: MOV  M,B 
       MOV  A,B 
       CALL H018A   
       PUSH B   
       LDA  H020C   
       MOV  B,A 
       MVI  C,0 
H0182: DCX  B   
       MOV  A,C 
       ORA  B   
       JNZ  H0182   
       POP  B   
       RET  
;   
H018A: PUSH B   
       PUSH D   
       PUSH H   
       PUSH PSW 
       SHLD H020F   
       MVI  D,0 
       MOV  B,D 
       MVI  A,'?'   
       SUB  L   
       ANI  03FH
       MOV  C,A 
       DAD  H   
       DAD  H   
       MVI  A,00FH  
       SUB  H   
       ANI  00FH
       MOV  E,A 
       XCHG 
       DAD  H   
       DAD  H   
       DAD  H   
       DAD  H   
       DAD  H   
       DAD  H   
       XCHG 
       LHLD H020F   
       MVI  A,0C0H  
       ANA  L   
       MOV  L,A 
       DAD  B   
       POP  PSW 
       MOV  M,A 
       PUSH PSW 
       LHLD H020F   
       MVI  A,0FCH  
       ANA  H   
       MOV  H,A 
       MVI  A,'?'   
       ANA  L   
       MOV  L,A 
       DAD  D   
       POP  PSW 
       MOV  M,A 
       LXI  H,SCREEN
       DAD  B   
       DAD  D   
       MOV  M,A 
       POP  H   
       POP  D   
       POP  B   
       RET  
;   
H01CD: POP  PSW 
       MOV  B,D 
       SHLD H5D49   
       MOV  H,E 
       DB   010H
       RM   
       POP  B   
       MOV  B,H 
       POP  H   
       STA  H0CF8   
       MOV  C,A 
       RAR  
       INX  B   
       CZ   HA2B2   
       ORA  D   
       MOV  B,C 
       DAD  B   
       ADC  B   
       MOV  B,D 
       DCR  B   
       CMP  D   
       ADD  D   
       MVI  M,01FH  
       DB   008H
       RLC  
       MOV  B,H 
       SHLD HABC3   
       STAX D   
       MOV  M,D 
       CPO  HE452   
       MOV  B,C 
       MOV  E,C 
       DCR  A   
       MOV  C,A 
       DCR  C   
       CMP  D   
       MOV  B,D 
       LXI  B,H4403 
       JNZ  H8992   
       MOV  B,H 
       DCX  B   
       POP  D   
       CALL HC3F8   
       DW   00110H  
H020B: DB   0   
H020C: DB   0   
H020D: DW  ZERO 
H020F: DW  ZERO 
H0211: DW  ZERO 
H0213: DW  ZERO 
H0215: CALL H0468   
       JMP  H0003   
H021B: CALL H0221   
       CPI  010H
       RET  
;   
H0221: SUI  030H
       CPI  LF  
       RC   
       SUI  007H
       RET  
;   
H0229: XRA  A   
       OUT  0FEH
       OUT  0C8H
       LXI  B,H0400 
       LXI  H,SCREEN
H0234: MVI  M,' '   
       INX  H   
       DCX  B   
       MOV  A,B 
       ORA  C   
       JNZ  H0234   
       RET  
;   
H023E: DW   SCREEN  
       DB   ' ** PATTERN **  '  
       DB   'Processor Technology Corporation'  
       DB   '  ** PATTERN ** '  
       DB   '****************'  
       DB   '****************'  
       DB   '****************'  
       DB   '****************'  
       DB   0FEH
H02C1: DW   HCCC4   
       DB   'INPUT VERTICAL AND HORIZONTAL' 
       DB   ' COMPONENTS in HEXADECIMAL'
       DB    ONES   
       DW   HCD0A   
       DB   'ie:   0,1,2,3,4,5,6,7,8,9,A,B,C,D,E,F' 
       DB    ONES   
       DW   HCD89   
       DB   'TYPE "X" for AUTOMATIC PATTERN GENERATION' 
       DB    ONES   
       DW   HCE0F   
       DB   'binary representation      HEX'
       DB    ONES   
       DW   HCE51   
       DW   07F7CH  
       DW   07F7CH  
       DW   07F7CH  
       DW   07F7CH  
       DB   07CH
       DW   07F7CH  
       DW   07F7CH  
       DW   07F7CH  
       DW   07F7CH  
       DB   07CH
       DB   '   =   00H'
       DB    ONES   
       DW   HCE8E   
       DB   'VERTICAL=' 
       NOP  
H039B: DW   HCE9B   
       DB   'HORIZONTAL='   
       NOP  
H03A9: DW   HCDCE   
       DB   'AUTOMATIC PATTERN GENERATION'  
       DB   0FEH
H03C8: DW   HCF01   
       DB   'TYPE "ESC" to EXIT to MONITOR,'
       DB   '   TYPE "DEL" to restart'  
H0400: DB   ' game.'
       DB    ONES   
       DW   HCF46   
       DB   'SPEED may be changed any time' 
       DB   ' during PATTERN generation'
       DB    ONES   
       DW   HCFC8   
       DB   'INPUT SPEED (1-9) to start PATTERN '   
       NOP  
H0467: INX  H   
H0468: MOV  E,M 
       INX  H   
       MOV  D,M 
H046B: INX  H   
       MOV  A,M 
       ORA  A   
       JZ   H0489   
       CPI  0FEH
       RZ   
       CPI  0FFH
       JZ   H0467   
       STAX D   
       INX  D   
       PUSH H   
       LXI  H,H00AF 
H047F: DCX  H   
       MOV  A,L 
       ORA  H   
       JNZ  H047F   
       POP  H   
       JMP  H046B   
H0489: INX  D   
       MVI  A,0BFH  
       STAX D   
       RET  
;   
       LXI  SP,H05A0
       CALL H0229   
       LXI  H,H04CB 
       CALL H0467   
       LXI  H,ZERO  
       LXI  D,ZERO  
       LXI  B,H056B 
H04A3: MOV  A,M 
       ADD  D   
       MOV  D,A 
       MOV  A,M 
       XRA  E   
       SUB  E   
       CMA  
       SUB  E   
       MOV  E,A 
       INX  H   
       MOV  A,H 
       CMP  B   
       JNZ  H04A3   
       MOV  A,L 
       CMP  C   
       JNZ  H04A3   
       LHLD H056C   
       MOV  A,H 
       SUB  D   
       JNZ  H04C5   
       MOV  A,L 
       SUB  E   
       JNZ  H04C5   
       HLT  
H04C5: LXI  H,H055A 
       CALL H0467   
H04CB: HLT  
       DW   HCC56   
       DB   '** Pattern **' 
       DB    ONES   
       DW   HCD13   
       DB   '# COPYRIGHT 1977 #'
       DB    ONES   
       DW   HCD5B   
       DB   'by'
       DB    ONES   
       DW   HCD8C   
       DB   'Processor Technology Corporation'  
       DB    ONES   
       DW   HCE0E   
       DB   ' Version 2.4   April 1, 1977'  
       DB    ONES   
       DW   HCF0D   
       DB   'PATTERN checksum -'
       DB    ONES   
       DW   HCF1F   
       DB   'Verified OK'   
H055A: DB   0FEH
       DW   HCF1F   
       DB   ' ### ERROR ###'
H056B: DB   0FEH
H056C: DW   H16EF   
       DW   ZERO
       DS   48  
H05A0: DW   ZERO
;   
LF     EQU   00AH   
CR     EQU   00DH   
ESC    EQU   01BH   
DEL    EQU   07FH   
ONES   EQU   0FFH   
ZERO   EQU 00000H   
H0700  EQU 00700H   
H0CF8  EQU 00CF8H   
H16EF  EQU 016EFH   
H4403  EQU 04403H   
H5D49  EQU 05D49H   
H8992  EQU 08992H   
HA2B2  EQU 0A2B2H   
HABC3  EQU 0ABC3H   
HC3F8  EQU 0C3F8H   
SCREEN EQU 0CC00H   
HCCC4  EQU 0CCC4H   
HCC56  EQU 0CC56H   
HCD0A  EQU 0CD0AH   
HCD13  EQU 0CD13H   
HCD5B  EQU 0CD5BH   
HCD89  EQU 0CD89H   
HCD8C  EQU 0CD8CH   
HCDCE  EQU 0CDCEH   
HCE0E  EQU 0CE0EH   
HCE0F  EQU 0CE0FH   
HCE51  EQU 0CE51H   
HCE58  EQU 0CE58H   
HCE61  EQU 0CE61H   
HCE6A  EQU 0CE6AH   
HCE6B  EQU 0CE6BH   
HCE8E  EQU 0CE8EH   
HCE98  EQU 0CE98H   
HCE9B  EQU 0CE9BH   
HCEA7  EQU 0CEA7H   
HCF01  EQU 0CF01H   
HCF0D  EQU 0CF0DH   
HCF1F  EQU 0CF1FH   
HCF46  EQU 0CF46H   
HCFC8  EQU 0CFC8H   
HD000  EQU 0D000H   
ALS8   EQU 0E060H   
CPM    EQU 00000H   
HE452  EQU 0E452H   
       END  
