;   LIFE.COM   GAME (DISPLAY) ( Processor Technology )  
       ORG 00100H   
       LXI SP,0CBFFH    ; Set up stack for Processor Tech. programs
       LXI  H,0C004H    ; Needed if ORG is other then address 0000H
       PUSH H  
       LXI  H,0C000H    ; Residue address needed if non-Processor Tech.
                        ; system (CP/M) is used to LOAD the PROGRAM.   
START: JMP    H0027 
H0003: CALL  H000A  
       JZ    H0003  
       RET  
;   
H000A: CALL   H001C 
       RZ   
       CPI   01BH   
       JZ    H0019  
       CPI   DEL
       JZ    H0051  
       RET  
;   
H0019: JMP   HE060      ; Modified later by program 
H001C: IN       000H
       NOP  
       ANI      040H
       RZ   
       IN       001H
       ANI   DEL
       RET  
;   
H0027: INX   H  
       MOV   A,M
       CPI   0C3H   
       JNZ   H004A  
       DCX   H  
       MOV   A,M
       CPI   000H   
       JZ    H003A  
       CPI   DEL
       JNZ   H004A  
H003A: MVI    L,01FH
       MOV   A,M
       CPI   03AH   
       JNZ   H004A  
H0042: SHLD     H000A+1 
       MVI    L,004H
       SHLD     H0019+1 
H004A: LXI    H,H0051   
       SHLD     START+1 
       PCHL 
H0051: LXI   SP,H0C99   
       XRA   A  
       STA   H0C61  
       STA   H0C62  
       STA   H089D  
       STA   H089E  
       CALL   H03FB 
H0064: LXI    H,H041C   
       CALL   H0795 
       LXI    H,H052F   
       CALL   H0795 
       LXI    H,H06F5   
       CALL   H0795 
       CALL   H03F0 
       LXI    H,H041C   
       CALL   H0795 
H007F: LXI    H,H049F   
       CALL   H0339 
       CPI   052H   
       JNZ   H0096  
       STA   H0C62  
       LXI    H,H076F   
       CALL   H0799 
       JMP   H00A1  
H0096: CPI   046H   
       JNZ   H007F  
       LXI    H,H077B   
       CALL   H0799 
H00A1: LXI    H,H04CE   
       CALL   H0339 
       CPI   04EH   
       JNZ   H00B2  
       CALL   H0367 
       JMP   H00BE  
H00B2: CALL   H0374 
       JNC   H00A1  
       STA   H089D  
       CALL   H035D 
H00BE: LXI    H,H04FC   
       CALL   H0339 
       CPI   04EH   
       JNZ   H00CF  
       CALL   H0367 
       JMP   H00DB  
H00CF: CALL   H0374 
       JNC   H00BE  
       STA   H089E  
       CALL   H035D 
H00DB: CALL   H03F0 
       LDA   H089D  
       ORA   A  
       JZ    H010C  
       CALL   H039F 
       XCHG 
       LXI    H,SCREEN  
H00EC: LDAX  D  
       MVI    C,008H
H00EF: RLC  
       JNC   H00F8  
       MVI    M,02AH
       JMP   H00FA  
H00F8: MVI    M,020H
H00FA: INX   H  
       INX   H  
       MOV   B,A
       MOV   A,H
H00FE: CPI   0D0H   
H0100: MOV   A,B
       JZ    H010C  
       DCR   C  
       JNZ   H00EF  
       INX   D  
       JMP   H00EC  
H010C: MVI    A,020H
       STA   H0899  
       MVI    A,007H
       STA   H089A  
H0116: MOV   A,M
       ANI   DEL
       MOV   M,A
       LXI    H,SCREEN  
       LDA   H089A  
       MOV   B,A
       XRA   A  
H0122: CMP   B  
       JZ    H012E  
       LXI    D,H0040   
       DAD   D  
       DCR   B  
       JMP   H0122  
H012E: LDA   H0899  
       MOV   E,A
       MVI    D,000H
       DAD   D  
       MOV   A,M
       ORI      080H
       MOV   M,A
H0139: CALL   H0003 
       CPI   051H   
       JZ    H010C  
       CPI   00EH   
       JZ    H010C  
       CPI   00BH   
       JNZ   H0151  
       CALL   H03FB 
       JMP   H010C  
H0151: CPI   001H   
       JNZ   H015C  
H0156: CALL   H0383 
       JMP   H0116  
H015C: CPI   041H   
       JNZ   H0166  
       MVI    M,02AH
       JMP   H0156  
H0166: CPI   013H   
       JNZ   H0171  
H016B: CALL   H037B 
       JMP   H0116  
H0171: CPI   053H   
       JNZ   H017B  
       MVI    M,02AH
       JMP   H016B  
H017B: CPI   017H   
       JNZ   H0186  
H0180: CALL   H0395 
       JMP   H0116  
H0186: CPI   057H   
       JNZ   H0190  
       MVI    M,02AH
       JMP   H0180  
H0190: CPI   01AH   
       JNZ   H019B  
H0195: CALL   H038E 
       JMP   H0116  
H019B: CPI   05AH   
       JNZ   H01A5  
       MVI    M,02AH
       JMP   H0195  
H01A5: CPI   020H   
       JNZ   H01B2  
       MVI    M,020H
       CALL   H037B 
       JMP   H0116  
H01B2: CALL   H036D 
       JNC   H0139  
       ANI      00FH
       STA   H089B  
       PUSH  H  
       CALL   H033F 
       POP   H  
       MOV   A,M
       ANI   DEL
       MOV   M,A
       LDA   H089E  
       ORA   A  
       JZ    H01F5  
       CALL   H039F 
       XCHG 
       LXI    H,HCBFE   
H01D4: MVI    C,008H
H01D6: INX   H  
       INX   H  
       MOV   B,A
       MOV   A,H
       CPI   0D0H   
       JZ    H01F5  
       MOV   A,M
       CPI   02AH   
       JZ    H01E9  
       ORA   A  
       JMP   H01EA  
H01E9: STC  
H01EA: MOV   A,B
       RAL  
       DCR   C  
       JNZ   H01D6  
       STAX  D  
       INX   D  
       JMP   H01D4  
H01F5: LDA   H089B  
       ORA   A  
       JNZ   H0202  
H01FC: CALL   H0003 
       JMP   H0208  
H0202: CALL   H000A 
       JZ    H0219  
H0208: CALL   H036D 
       JNC   H0219  
       ANI      00FH
       STA   H089B  
       JZ    H01FC  
       CALL   H033F 
H0219: CALL   H0346 
       XRA   A  
       STA   H0899  
       STA   H089A  
       LXI    H,H08A1   
       SHLD     H089F   
       LXI    H,SCREEN  
H022C: SHLD     H0C63   
       XRA   A  
       STA   H0C66  
       LXI    D,HFFBE   
       CALL   H03B1 
       JZ    H0246  
       DAD   D  
       CALL   H03CE 
       JZ    H0246  
       CALL   H0410 
H0246: LXI    D,HFFC0   
       LHLD     H0C63   
       CALL   H03CE 
       JZ    H0256  
       DAD   D  
       CALL   H0410 
H0256: LXI    D,HFFC2   
       LHLD     H0C63   
       CALL   H03BF 
       JZ    H026C  
       DAD   D  
       CALL   H03CE 
       JZ    H026C  
       CALL   H0410 
H026C: LXI    D,TWO 
       LHLD     H0C63   
       CALL   H03BF 
       JZ    H027C  
       DAD   D  
       CALL   H0410 
H027C: LXI    D,H0042   
       LHLD     H0C63   
       CALL   H03BF 
       JZ    H0292  
       DAD   D  
       CALL   H03DC 
       JZ    H0292  
       CALL   H0410 
H0292: LXI    D,H0040   
       LHLD     H0C63   
       CALL   H03DC 
       JZ    H02A2  
       DAD   D  
       CALL   H0410 
H02A2: LXI    D,H003E   
       LHLD     H0C63   
       CALL   H03B1 
       JZ    H02B8  
       DAD   D  
       CALL   H03DC 
       JZ    H02B8  
       CALL   H0410 
H02B8: LXI    D,HFFFE   
       LHLD     H0C63   
       CALL   H03B1 
       JZ    H02C8  
       DAD   D  
       CALL   H0410 
H02C8: LHLD     H089F   
       XCHG 
       LHLD     H0C63   
       LDA   H0C66  
       CPI   002H   
       JC    H02E5  
       CPI   003H   
       JC    H02EB  
       JNZ   H02E5  
       MVI    A,02AH
       STAX  D  
       JMP   H02ED  
H02E5: MVI    A,020H
       STAX  D  
       JMP   H02ED  
H02EB: MOV   A,M
       STAX  D  
H02ED: INX   H  
       INX   H  
       INX   D  
       XCHG 
       SHLD     H089F   
       XCHG 
       CALL   H037B 
       JNZ   H022C  
       CALL   H038E 
       JNZ   H022C  
       LXI    D,H08A1   
       LXI    H,SCREEN  
       XRA   A  
       STA   H089C  
H030B: LDAX  D  
       MOV   M,A
       CPI   02AH   
       JNZ   H0315  
       STA   H089C  
H0315: INX   D  
       INX   H  
       INX   H  
       MOV   A,H
       CPI   0D0H   
       JNZ   H030B  
       LDA   H089C  
       ORA   A  
       JNZ   H01F5  
       MVI    D,002H
       CALL   H034F 
H032A: LXI    H,H0754   
       CALL   H0795 
       LXI    H,H06B5   
       CALL   H0339 
       JMP   H032A  
H0339: CALL   H0795 
       JMP   H0003  
H033F: RAR  
       ANI      00FH
       STA   H0C61  
       RET  
;   
H0346: LDA   H089B  
       ORA   A  
       RZ   
       LDA   H0C61  
       MOV   D,A
H034F: DCR   D  
       RM   
       LXI    H,ZERO
H0354: DCX   H  
       MOV   A,H
       ORA   L  
       JNZ   H0354  
       JMP   H034F  
H035D: PUSH  PSW
       LXI    H,H0786   
       CALL   H0799 
       POP   PSW
       STAX  D  
       RET  
;   
H0367: LXI    H,H0791   
       JMP   H0799  
H036D: CPI   02FH   
       CMC  
       RNC  
       CPI   03AH   
       RET  
;   
H0374: CPI   031H   
       CMC  
       RNC  
       CPI   038H   
       RET  
;   
H037B: LDA   H0899  
       INR   A  
       INR   A  
       JMP   H0388  
H0383: LDA   H0899  
       DCR   A  
       DCR   A  
H0388: ANI      03FH
       STA   H0899  
       RET  
;   
H038E: LDA   H089A  
       INR   A  
       JMP   H0399  
H0395: LDA   H089A  
       DCR   A  
H0399: ANI      00FH
       STA   H089A  
       RET  
;   
H039F: LXI    H,H0AA1   
       ANI      007H
       DCR   A  
       MOV   C,A
H03A6: XRA   A  
       CMP   C  
       RZ   
       LXI    D,H0040   
       DAD   D  
       DCR   C  
       JMP   H03A6  
H03B1: LDA   H0899  
       ORA   A  
       RNZ  
       CALL   H03EB 
       RZ   
        LXI   B,H0040   
       DAD   B  
       RET  
;   
H03BF: LDA   H0899  
       CPI   03EH   
       RNZ  
       CALL   H03EB 
       RZ   
        LXI   B,HFFC0   
       DAD   B  
       RET  
;   
H03CE: LDA   H089A  
       ORA   A  
       RNZ  
       CALL   H03EB 
       RZ   
        LXI   B,H0400   
       DAD   B  
       RET  
;   
H03DC: LDA   H089A  
       CPI   00FH   
       RNZ  
       CALL   H03EB 
       RZ   
        LXI   B,HFC00   
       DAD   B  
       RET  
;   
H03EB: LDA   H0C62  
       ORA   A  
       RET  
;   
H03F0: LXI    H,H0734   
       CALL   H0339 
       CPI   020H   
       JNZ   H03F0  
H03FB: XRA   A  
       OUT      0FEH
       OUT      0C8H
H0400:  LXI   B,H0400   
       LXI    H,SCREEN  
H0406: MVI    M,020H
       INX   H  
       DCX   B  
       MOV   A,B
       ORA   C  
       JNZ   H0406  
       RET  
;   
H0410: MOV   A,M
       CPI   02AH   
       RNZ  
       LDA   H0C66  
       INR   A  
       STA   H0C66  
       RET  
;   
H041C: DB   0,0CCH  
       DB   ' *** LIFE ***   '  
       DB   'Processor Technology Corporation'  
       DB   '   *** LIFE *** '  
       DB   '****************'  
       DB   '****************'  
       DB   '****************'  
       DB   '****************'  
       DB   MINUS   
H049F: DB        0,0CDH 
       DB   'Do you want a ROUND or FLAT world? (R or F) '  
       NOP  
H04CE: DB   0,0CEH  
       DB   'Do you want a previous PATTERN? (1-7 or N) '   
       NOP  
H04FC: DB   0,0CFH  
       DB   'Do you want to SAVE the new PATTERN? (1-7 or N) '  
       NOP  
H052F: DB   080H,0CCH   
       DB   'To deposit CELL then move CURSOR type:'
       DB   SETT
       DB   0,0CDH  
       DB   '"W"=UP   "S"=RIGHT   "Z"= DOWN   "A"= LEFT'
       DB   '   "Q"= CENTER CURSOR' 
       DB   SETT
       DB   040H,0CDH   
       DB   '   SPACE BAR= ERASE CELL           '   
       DB   'Control/K= Clear Screen'   
       DB   SETT
       DB   0C0H,0CDH   
       DB   'To move CURSOR (No deposit):'  
       DB   SETT
       DB   0,0CEH  
       DB   '   Hold CONTROL key down, and type MOVE key (above).'  
       DB   SETT
       DB   080H,0CEH   
       DB   'Generation speed (0-9) may be changed at any time.'
       DB   SETT
       DB   0C0H,0CEH   
       DB   '   1 = Fastest         9 = Slowest'
       DB   SETT
       DB   0,0CFH  
       DB   '   0 = Single step, type SPACE BAR to step.'   
       DB   SETT
H06B5: DB   040H,0CFH   
       DB   'Type "ESC" to EXIT to MONITOR,   Type "DEL"  to restart game.' 
       DB   MINUS   
H06F5: DB   080H,0CFH   
       DB   'When PATTERN is ready, type speed key (0-9) to start action.'  
       DB   SETT
H0734: DB   0C0H,0CFH   
       DB   '   Type SPACE BAR when ready ' 
       NOP  
H0754: DB   014H,0CEH   
       DB   'All LIFE has disappeared'  
       DB   MINUS   
H076F: DB   'Round WORLD'   
       DB   MINUS   
H077B: DB   'Flat WORLD'
       DB   MINUS   
H0786: DB   'REGISTER  '
       DB   MINUS   
H0791: DB   'NO'
       DB   0FEH
H0794: INX  H   
H0795: MOV   E,M
       INX   H  
       MOV   D,M
H0798: INX   H  
H0799: MOV   A,M
       ORA   A  
       JZ    H07B6  
       CPI   0FEH   
       RZ   
       CPI   0FFH   
       JZ    H0794  
       STAX  D  
       INX   D  
       PUSH  H  
       LXI    H,H0064   
H07AC: DCX   H  
       MOV   A,L
       ORA   H  
       JNZ   H07AC  
       POP   H  
       JMP   H0798  
H07B6: INX   D  
       MVI    A,0BFH
       STAX  D  
       RET  
;   
       LXI   SP,H1000   
       LXI    H,SCREEN  
       CALL   H03FB 
       LXI    H,H07FB   
       CALL   H0794 
       LXI    H,ZERO
       LXI    D,ZERO
        LXI   B,H0896   
H07D3: MOV   A,M
       ADD   D  
       MOV   D,A
       MOV   A,M
       XRA   E  
       SUB   E  
       CMA  
       SUB   E  
       MOV   E,A
       INX   H  
       MOV   A,H
       CMP   B  
       JNZ   H07D3  
       MOV   A,L
       CMP   C  
       JNZ   H07D3  
       LHLD     H0897   
       MOV   A,H
       SUB   D  
       JNZ   H07F5  
       MOV   A,L
       SUB   E  
       JNZ   H07F5  
    HLT 
H07F5: LXI    H,H0885   
       CALL   H0794 
H07FB: HLT  
       DB   056H,0CCH   
       DB   '*** Life ***'  
       DB   SETT
       DB   013H,0CDH   
       DB   '# COPYRIGHT 1977 #'
       DB   SETT
       DB   05BH,0CDH   
       DB   'by'
       DB   SETT
       DB   08CH,0CDH   
       DB   'PROCESSOR TECHNOLOGY CORPORATION'  
       DB   SETT
       DB   CR,0CEH 
       DB   'Version 2.4   January 7, 1977' 
       DB   SETT
       DB   CR,0CFH 
       DB   'LIFE Checksum - Verified OK'   
H0885: DB   MINUS   
       DB   01CH,0CFH   
       DB   ' ### ERROR ###'
H0896: DB   MINUS   
H0897: DW   H9C92   
H0899: DB    ' '
H089A: RLC  
H089B: INX   H  
H089C: INX   H  
H089D: NOP  
H089E: NOP  
H089F: DB    020H   
       RLC  
H08A1:  LXI   B,H3100   
       NOP  
       ANA   A  
       LDAX  B  
       DB   '         ' 
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB   '                '  
       DB    ' '
H0AA1: DW   ZERO
       DW   ZERO
       DW   ZERO
       DW   ZERO
       MOV   H,B
       INR   A  
       CPI   DEL
       MOV   H,B
       INR   A  
       CPI   DEL
       MOV   H,B
       DB    018H   
       RNZ  
       MOV   H,B
       MOV   H,B
       DB    018H   
       RNZ  
       MOV   H,B
       MOV   H,B
       DB    018H   
       RNZ  
       MOV   H,B
       MOV   H,B
       DB    018H   
       CM    H607E  
       DB    018H   
       CM    H607E  
       DB    018H   
       RNZ  
       MOV   H,B
       MOV   H,B
       DB    018H   
       RNZ  
       MOV   H,B
       MOV   H,B
       DB    018H   
       RNZ  
       MOV   H,B
       MOV   A,A
       INR   A  
       RNZ  
       MOV   A,A
       MOV   A,A
       INR   A  
       RNZ  
       MOV   A,A
       DB   0,0,0,0,0,0,0,0,0,0 
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0
       DB   1,0C0H,0,0  
       DB   1,0C0H,0,0  
       DB   1,0C0H,0,0  
       DB   1,0C0H,0,0  
       NOP  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0  
       DB   080H,0,0,0,080H 
       DB   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 
       DB   0,0,0,0,0,0 
       DB   3,0E0H,0,0,0
       DB   040H,0,0,0  
       DB   080H,0,0
       DB   1,0,0,0 
       DB   3,0E0H  
       DB   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 
       DB   0,0,0,0,0,0,0,0 
       DW   TWO 
       DW   TWO 
       DW   FOUR
       DW   FOUR
       DW   EIGHT   
       DB   0,0F8H,0,010H,0,0F0H,0,020H,0,030H,0
       DB   040H,0,0,0  
       DB   080H,0,0,0,0
       DB   1,080H,1,0,2,080H,2 
       DW   TWO 
       DW   TWO 
       DW   EIGHT   
       DW   EIGHT   
       DW   TEN 
       DW   TEN 
       DW   TWEN
       DW   TWEN
       DW   FORTY   
       DW   FORTY   
       DW   EIGHTY  
       DW   EIGHTY  
       DB   1,0,1   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DB   0,0,0,080H  
       DB   0,0,0,080H  
       NOP  
       MOV   M,B
       NOP  
       ADD   B  
       RLC  
       NOP  
       RPO  
       INX   B  
       ADD   B  
       NOP  
       RPO  
       INX   B  
       ADD   B  
       NOP  
       RPO  
       INX   B  
       ADD   B  
       RLC  
       NOP  
       NOP  
       MOV   M,B
       RLC  
       NOP  
       ADD   B  
       MOV   M,B
       RLC  
        LXI   B,H70C0   
       NOP  
       NOP  
       ADD   B  
       NOP  
       NOP  
       NOP  
       NOP  
       NOP  
       DB    030H   
       MOV   B,B
        LXI   B,H3006   
       DB    030H   
        MVI   B,006H
       INR   C  
       RNZ  
        LXI   B,H0C98   
       DB    020H   
       STAX  B  
       DB    018H   
       DB   0,0,0,0 
H0C61: NOP  
H0C62: NOP  
H0C63: DB   0,0,0   
H0C66: DW   ZERO
       DB   052H,0FEH,0CFH,0,5,039H 
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       DW   ANINE   
       NOP  
       INR   H  
       CPI   0F6H   
       DB    0FDH   
       MVI    L,0C0H
       DCR   C  
       NOP  
        MVI   B,000H
       ORI      003H
       MOV   A,C
H0C98: NOP  
H0C99: RRC  
       NOP  
       RRC  
       NOP  
       MOV   C,M
        LXI   B,H1E39   
       STAX  B  
       DB   'et speed and start the game:  1 = FASTEST '
       DW  ZERO 
       DW  ZERO 
ZERO   EQU 00000H   
CPM    EQU 00000H   
LF     EQU   00AH   
CR     EQU   00DH   
ESC    EQU   01BH   
DEL    EQU   07FH   
MINUS  EQU   0FEH   
SETT   EQU   0FFH   
TWO    EQU 00200H   
FOUR   EQU 00400H   
EIGHT  EQU 00800H   
ANINE  EQU 03900H   
TEN    EQU 01000H   
TWEN   EQU 02000H   
FORTY  EQU 02000H   
EIGHTY EQU 08000H   
H003E  EQU 0003EH   
H0040  EQU 00040H   
H1000  EQU 01000H   
H1E39  EQU 01E39H   
H3006  EQU 03006H   
H3100  EQU 03100H   
H607E  EQU 0607EH   
H70C0  EQU 070C0H   
H9C92  EQU 09C92H   
HCBFE  EQU 0CBFEH   
SCREEN EQU 0CC00H   
HE060  EQU 0E060H   
HFC00  EQU 0FC00H   
HFFBE  EQU 0FFBEH   
HFFC0  EQU 0FFC0H   
HFFC2  EQU 0FFC2H   
HFFFE  EQU 0FFFEH   
       END  
